Clazz.declarePackage ("J.shapespecial");
Clazz.load (null, "J.shapespecial.Polyhedron", ["java.lang.Float", "java.util.Hashtable", "JU.AU", "$.P3", "$.V3"], function () {
c$ = Clazz.decorateAsClass (function () {
this.modelIndex = 0;
this.centralAtom = null;
this.vertices = null;
this.nVertices = 0;
this.visible = false;
this.normixes = null;
this.faces = null;
this.visibilityFlags = 0;
this.collapsed = false;
this.faceCenterOffset = 0;
this.distanceFactor = 0;
this.planarParam = 0;
this.isFullyLit = false;
this.isValid = true;
this.colixEdge = 0;
this.smiles = null;
this.smarts = null;
this.pointGroup = null;
this.volume = null;
Clazz.instantialize (this, arguments);
}, J.shapespecial, "Polyhedron");
Clazz.makeConstructor (c$, 
function (centralAtom, nVertices, nPoints, planeCount, otherAtoms, normixes, planes, collapsed, faceCenterOffset, distanceFactor, planarParam) {
this.centralAtom = centralAtom;
this.modelIndex = centralAtom.mi;
this.nVertices = nVertices;
this.vertices =  new Array (nPoints + 1);
this.visible = true;
this.normixes =  Clazz.newShortArray (planeCount, 0);
this.faces = JU.AU.newInt2 (planeCount);
for (var i = nPoints + 1; --i >= 0; ) this.vertices[i] = otherAtoms[i];

for (var i = planeCount; --i >= 0; ) this.normixes[i] = normixes[i];

for (var i = planeCount; --i >= 0; ) this.faces[i] = planes[i];

this.collapsed = collapsed;
this.faceCenterOffset = faceCenterOffset;
this.distanceFactor = distanceFactor;
this.planarParam = planarParam;
}, "JM.Atom,~N,~N,~N,~A,~A,~A,~B,~N,~N,~N");
Clazz.defineMethod (c$, "getInfo", 
function (vwr) {
var info =  new java.util.Hashtable ();
var energy = vwr.ms.getInfo (this.centralAtom.mi, "Energy");
if (energy != null) info.put ("energy", energy);
info.put ("modelIndex", Integer.$valueOf (this.centralAtom.mi));
info.put ("modelNumber", Integer.$valueOf (this.centralAtom.getModelNumber ()));
info.put ("center", JU.P3.newP (this.centralAtom));
info.put ("atomIndex", Integer.$valueOf (this.centralAtom.i));
info.put ("atomNumber", Integer.$valueOf (this.centralAtom.getAtomNumber ()));
info.put ("atomName", this.centralAtom.getInfo ());
info.put ("element", this.centralAtom.getElementSymbol ());
info.put ("vertexCount", Integer.$valueOf (this.nVertices));
info.put ("vertices", JU.AU.arrayCopyPt (this.vertices, this.nVertices));
info.put ("faceCount", Integer.$valueOf (this.faces.length));
info.put ("faces", JU.AU.arrayCopyII (this.faces, this.faces.length));
info.put ("volume", this.getVolume ());
if (this.smarts != null) info.put ("smarts", this.smarts);
if (this.smiles != null) info.put ("smiles", this.smiles);
if (this.pointGroup != null) info.put ("pointGroup", this.pointGroup.getPointGroupName ());
return info;
}, "JV.Viewer");
Clazz.defineMethod (c$, "getSymmetry", 
function (vwr, withPointGroup) {
var sm = vwr.getSmilesMatcher ();
try {
if (this.smarts == null) {
this.smarts = sm.polyhedronToSmiles (this.faces, this.nVertices, null);
this.smiles = sm.polyhedronToSmiles (this.faces, this.nVertices, this.vertices);
}} catch (e) {
if (Clazz.exceptionOf (e, Exception)) {
} else {
throw e;
}
}
if (this.pointGroup == null && withPointGroup) this.pointGroup = vwr.ms.getSymTemp (true).setPointGroup (null, this.vertices, null, false, vwr.getFloat (570425382), vwr.getFloat (570425384), true);
}, "JV.Viewer,~B");
Clazz.defineMethod (c$, "getVolume", 
 function () {
if (this.volume != null) return this.volume;
var vAB =  new JU.V3 ();
var vAC =  new JU.V3 ();
var vTemp =  new JU.V3 ();
var v = 0;
for (var i = this.faces.length; --i >= 0; ) {
var face = this.faces[i];
for (var j = face.length - 2; --j >= 0; ) if (face[j + 2] >= 0) v += this.triangleVolume (face[j], face[j + 1], face[j + 2], vAB, vAC, vTemp);

}
return Float.$valueOf (v / 6);
});
Clazz.defineMethod (c$, "triangleVolume", 
 function (i, j, k, vAB, vAC, vTemp) {
vAB.setT (this.vertices[i]);
vAC.setT (this.vertices[j]);
vTemp.cross (vAB, vAC);
vAC.setT (this.vertices[k]);
return vAC.dot (vTemp);
}, "~N,~N,~N,JU.V3,JU.V3,JU.V3");
Clazz.defineMethod (c$, "getState", 
function () {
var ptemp =  new JU.P3 ();
var s = "({" + this.centralAtom.i + "}) TO [";
for (var i = 0; i < this.nVertices; i++) {
ptemp.setT (this.vertices[i]);
s += ptemp;
}
s += "]";
return "  polyhedra " + s + (this.collapsed ? " collapsed" : "") + " distanceFactor " + this.distanceFactor + " faceCenterOffset " + this.faceCenterOffset + (this.isFullyLit ? " fullyLit" : "") + ";" + (this.visible ? "" : "polyhedra off;") + "\n";
});
});
